'==========================================================================
'Multispaced font managing routines                     lpardini@cefex.com
'==========================================================================
' For information, press F5.
'==========================================================================
'                                         | I like mail, so contact me for
'__________   ____---____                 | any  doubt or  suggestion  you
'\_________D /-/---_----'            LL&P | have for this/another program,
'       _H__/_/           Leandro Pardini | for  get my  last routines, to
'      '-_____|(       lpardini@cefex.com | chat  about  computers  and/or
'                                         | programming or to say "Hello".
'==========================================================================
'$STATIC
DEFINT A-Z

DECLARE SUB CharPrint (PosX%, PosY%, Char%, Clr%, Style%)
DECLARE SUB TextCenter (PosX1%, PosX2%, PosY%, Text$, Clr%, Style%)
DECLARE SUB TextRight (PosX%, PosY%, Text$, Clr%, Style%)
DECLARE SUB TextPrint (PosX%, PosY%, Text$, Clr%, Style%)
DECLARE FUNCTION TextLen% (Text$, Style%)

CONST True = -1
CONST False = 0

CONST Normal = 0
CONST Italics = 1
CONST Bold = 2

DIM SHARED FontData%(223, 16)

'Load the serif font
OPEN "SSERIF.FON" FOR BINARY ACCESS READ AS #1
   IF LOF(1) > 0 THEN
      FOR FontRead% = 0 TO 223
         GET #1, , FontData%(FontRead%, 0)
         FOR FontLine% = 1 TO FontData%(FontRead%, 0)
            GET #1, , FontData%(FontRead%, FontLine%)
         NEXT FontLine%
      NEXT FontRead%
   ELSE
      PRINT "Can't load SSERIF.FON"
      SYSTEM
   END IF
CLOSE #1

SCREEN 12
LINE (0, 0)-(639, 15), 9, BF
LINE (0, 16)-(639, 463), 7, BF
LINE (0, 464)-(639, 479), 9, BF

CALL TextCenter(0, 639, 1, "Multispaced Font Managing Routines v1.5", 15, Bold)
CALL TextCenter(0, 639, 465, "Leandro Pardini - lpardini@cefex.com", 15, Bold)

CALL TextPrint(8, 32, "This file contains five SUBs that can help you to create nice screens. You are bored of DOS monospaced font? Me too!", 0, Normal)
CALL TextPrint(8, 48, "So I created this multispaced font managing routines, and included an example font that looks like Arial, but several", 0, Normal)
CALL TextPrint(8, 64, "codes missing. I'm working on a program that converts TrueType fonts to my own format, but it can take a very long", 0, Normal)
CALL TextPrint(8, 80, "time to complete.", 0, Normal)

px = 8
CALL TextPrint(px, 112, "You can use the ", 0, Normal)
CALL TextPrint(px, 112, "SUB TextPrint", 0, Italics)
CALL TextPrint(px, 112, " to show a string on screen. Because centered text looks very good, I added the ", 0, Normal)

px = 8
CALL TextPrint(px, 128, "SUB TextCenter", 0, Italics)
CALL TextPrint(px, 128, " to show a string centered in some area. In order to make it work, you must tell the SUB the left and", 0, Normal)
CALL TextPrint(8, 144, "right margings of your text area.", 0, Normal)

px = 8
CALL TextPrint(px, 176, "The ", 0, Normal)
CALL TextPrint(px, 176, "SUB CharPrint", 0, Italics)
CALL TextPrint(px, 176, " is the heart of all my routines. It's ", 0, Normal)
CALL TextPrint(px, 176, "very", 0, Bold)
CALL TextPrint(px, 176, " slow, because I use standard PSET, in order to make it", 0, Normal)

CALL TextPrint(8, 192, "compatible with all screen modes. It prints only one char to specified x-y coordinates, and increases passed variables as", 0, Normal)
CALL TextPrint(8, 208, "needed. It doesn't word wrap when text reaches screen border, because I can't know you're working with 640 or 320", 0, Normal)
CALL TextPrint(8, 224, "screen width. Maybe in a near future.", 0, Normal)

px = 8
CALL TextPrint(px, 256, "The routines print text in four styles: Normal, ", 0, Normal)
CALL TextPrint(px, 256, "Bold, ", 0, Bold)
CALL TextPrint(px, 256, "Italics ", 0, Italics)
CALL TextPrint(px, 256, "and ", 0, Normal)
CALL TextPrint(px, 256, "Bold+Italics", 0, Bold + Italics)
CALL TextPrint(px, 256, ". If you want to combine many styles in the", 0, Normal)
CALL TextPrint(8, 272, "same line, you can create a variable and call the routines using it, instead of using direct values. The variable will be", 0, Normal)
CALL TextPrint(8, 288, "updated each time you print a character, so you can make several calls with several atributes.", 0, Normal)
px = 8
CALL TextPrint(px, 336, "One more word: ", 0, Normal)
CALL TextPrint(px, 336, "c", 14, Bold)
CALL TextPrint(px, 336, "o", 4, Bold)
CALL TextPrint(px, 336, "l", 5, Bold)
CALL TextPrint(px, 336, "o", 6, Bold)
CALL TextPrint(px, 336, "r", 9, Bold)
CALL TextPrint(px, 336, ". Yes, you can use all the colors you want.", 0, Normal)
CALL TextRight(630, 320, "Also, you can use the", 0, Normal)
CALL TextRight(630, 336, "SUB TextRight", 0, Italics)
CALL TextRight(630, 352, "to print right-justified text", 0, Normal)
px = 8
CALL TextPrint(px, 384, "The ", 0, Normal)
CALL TextPrint(px, 384, "FUNCTION TextLen% ", 0, Italics)
CALL TextPrint(px, 384, "can be used to get the lenght of a string in specified style, so you can do things like", 0, Normal)
CALL TextPrint(8, 400, "centering while changing colors and styles. An example? Look at this:", 0, Normal)

w1$ = "I ": w2$ = "believe ": w3$ = "you'll ": w4$ = "never ": w5$ = "print ": w6$ = "a ": w7$ = "line ": w8$ = "like ": w9$ = "this! "

Lng% = TextLen%(w1$, Bold) + TextLen%(w2$, Italics) + TextLen%(w3$, Normal) + TextLen%(w4$, Bold) + TextLen%(w5$, Italics + Bold) + TextLen%(w6$, Bold) + TextLen%(w7$, Italics) + TextLen%(w8$, Normal) + TextLen%(w9$, Bold)

px = 320 - (Lng% \ 2)
CALL TextPrint(px, 432, w1$, 9, Bold)
CALL TextPrint(px, 432, w2$, 14, Italics)
CALL TextPrint(px, 432, w3$, 1, Normal)
CALL TextPrint(px, 432, w4$, 5, Bold)
CALL TextPrint(px, 432, w5$, 4, Italics + Bold)
CALL TextPrint(px, 432, w6$, 6, Bold)
CALL TextPrint(px, 432, w7$, 13, Italics)
CALL TextPrint(px, 432, w8$, 15, Normal)
CALL TextPrint(px, 432, w9$, 0, Bold)

WHILE INKEY$ = "": WEND

LINE (0, 16)-(639, 463), 7, BF

CALL TextPrint(8, 32, "In the next version, I plan to add the dinamic style change. What's this? Simple. If you call TextPrint using this:", 0, Normal)
CALL TextPrint(8, 64, "CALL TextPrint(8, 128, " + CHR$(34) + "^C0FThis word is in ^Bbold^b, ^C00this in ^Iitalics^i ^C08and this in ^B^Iboth^i^b." + CHR$(34) + ")", 0, Normal)
CALL TextPrint(8, 96, "The SUB will put the text in screen this way:", 0, Normal)

px = 8
CALL TextPrint(px, 128, "This word is in ", 15, Normal)
CALL TextPrint(px, 128, "bold", 15, Bold)
CALL TextPrint(px, 128, ", ", 15, Normal)
CALL TextPrint(px, 128, "this in ", 0, Normal)
CALL TextPrint(px, 128, "italics", 0, Italics)
CALL TextPrint(px, 128, " ", 0, Normal)
CALL TextPrint(px, 128, "and this in ", 8, Normal)
CALL TextPrint(px, 128, "both", 8, Bold + Italics)
CALL TextPrint(px, 128, ".", 8, Normal)

CALL TextPrint(8, 160, "replacing 10 lines of actual code. But I think I'll need two or three months to complete it. Then, the next feature I wish to", 0, Normal)
CALL TextPrint(8, 176, "add is full text justification.", 0, Normal)

CALL TextPrint(8, 208, "If you want to see all this routines (except TextRight) in action, just take a look to ENCODE.BAS, a program you can find", 0, Normal)
CALL TextPrint(8, 224, "in the ABC Packets of July 1998.", 0, Normal)

px = 8
CALL TextPrint(px, 256, "If you want to use the routines in your own programs, go ahead. Please add something like ", 0, Normal)
CALL TextPrint(px, 256, "Font routines made by", 0, Italics)
px = 8
CALL TextPrint(px, 272, "Leandro Pardini <lpardini@cefex.com>. ", 0, Italics)
CALL TextPrint(px, 272, "You don't need to do so, but I'll like it.", 0, Normal)

WHILE INKEY$ = "": WEND

SCREEN 0
CLS
SYSTEM

'========================<lpardini@cefex.com>=
'Shows a character using the multispaced font.
'PosX%  Pixel X position
'PosY%  Pixel Y position
'Char%  iso-8859-1 character code
'Clr%   Color attribute for printing
'Style% Normal, Bold, Italic, or Bold+Italic
'=============================================
SUB CharPrint (PosX%, PosY%, Char%, Clr%, Style%)

Letter% = Char% - 32
IF Letter% < 0 THEN Letter% = 0

FOR Show% = 1 TO FontData%(Letter%, 0)
 
   IF (Style% AND 1) = 0 THEN
      IF (FontData%(Letter%, Show%) AND 4096) THEN PSET (PosX% + Show%, PosY%), Clr%
      IF (FontData%(Letter%, Show%) AND 2048) THEN PSET (PosX% + Show%, PosY% + 1), Clr%
      IF (FontData%(Letter%, Show%) AND 1024) THEN PSET (PosX% + Show%, PosY% + 2), Clr%
      IF (FontData%(Letter%, Show%) AND 512) THEN PSET (PosX% + Show%, PosY% + 3), Clr%
      IF (FontData%(Letter%, Show%) AND 256) THEN PSET (PosX% + Show%, PosY% + 4), Clr%
      IF (FontData%(Letter%, Show%) AND 128) THEN PSET (PosX% + Show%, PosY% + 5), Clr%
      IF (FontData%(Letter%, Show%) AND 64) THEN PSET (PosX% + Show%, PosY% + 6), Clr%
      IF (FontData%(Letter%, Show%) AND 32) THEN PSET (PosX% + Show%, PosY% + 7), Clr%
      IF (FontData%(Letter%, Show%) AND 16) THEN PSET (PosX% + Show%, PosY% + 8), Clr%
      IF (FontData%(Letter%, Show%) AND 8) THEN PSET (PosX% + Show%, PosY% + 9), Clr%
      IF (FontData%(Letter%, Show%) AND 4) THEN PSET (PosX% + Show%, PosY% + 10), Clr%
      IF (FontData%(Letter%, Show%) AND 2) THEN PSET (PosX% + Show%, PosY% + 11), Clr%
      IF (FontData%(Letter%, Show%) AND 1) THEN PSET (PosX% + Show%, PosY% + 12), Clr%
   ELSE
      IF (FontData%(Letter%, Show%) AND 4096) THEN PSET (PosX% + Show% + 3, PosY%), Clr%
      IF (FontData%(Letter%, Show%) AND 2048) THEN PSET (PosX% + Show% + 3, PosY% + 1), Clr%
      IF (FontData%(Letter%, Show%) AND 1024) THEN PSET (PosX% + Show% + 3, PosY% + 2), Clr%
      IF (FontData%(Letter%, Show%) AND 512) THEN PSET (PosX% + Show% + 2, PosY% + 3), Clr%
      IF (FontData%(Letter%, Show%) AND 256) THEN PSET (PosX% + Show% + 2, PosY% + 4), Clr%
      IF (FontData%(Letter%, Show%) AND 128) THEN PSET (PosX% + Show% + 2, PosY% + 5), Clr%
      IF (FontData%(Letter%, Show%) AND 64) THEN PSET (PosX% + Show% + 1, PosY% + 6), Clr%
      IF (FontData%(Letter%, Show%) AND 32) THEN PSET (PosX% + Show% + 1, PosY% + 7), Clr%
      IF (FontData%(Letter%, Show%) AND 16) THEN PSET (PosX% + Show% + 1, PosY% + 8), Clr%
      IF (FontData%(Letter%, Show%) AND 8) THEN PSET (PosX% + Show%, PosY% + 9), Clr%
      IF (FontData%(Letter%, Show%) AND 4) THEN PSET (PosX% + Show%, PosY% + 10), Clr%
      IF (FontData%(Letter%, Show%) AND 2) THEN PSET (PosX% + Show%, PosY% + 11), Clr%
      IF (FontData%(Letter%, Show%) AND 1) THEN PSET (PosX% + Show%, PosY% + 12), Clr%
   END IF
  
   IF (Style% AND 2) THEN
      CharPrint PosX% + 1, PosY%, Char%, Clr%, (Style% AND 1)
   END IF

NEXT Show%
     
PosX% = PosX% + FontData%(Letter%, 0) + 1
IF (Style% AND 2) THEN PosX% = PosX% + 1

END SUB

'===================<lpardini@cefex.com>=
'Centers a string using multispaced font.
'PosX1% Left pixel X position of area
'PosX2% Right pixel X position of area
'PosY%  Pixel Y position
'Text$  iso-8859-1 string
'Clr%   Color attribute for printing
'Style% Normal, Bold, Italic, or Bold+Italic
'========================================
SUB TextCenter (PosX1%, PosX2%, PosY%, Text$, Clr%, Style%)
   TextWidth% = TextLen%(Text$, Style%)
   MidPos% = PosX1% + ((PosX2% - PosX1%) \ 2)
   TextPrint MidPos% - (TextWidth% \ 2), PosY%, Text$, Clr%, Style%
END SUB

'=========================================<lpardini@cefex.com>=
'Returns the pixel lenght of a string with my multispaced font.
'Text$  iso-8859-1 string
'Style% Normal, Bold, Italic, or Bold+Italic
'==============================================================
FUNCTION TextLen% (Text$, Style%)
  
   FOR Proc% = 1 TO LEN(Text$)
      Letter% = ASC(MID$(Text$, Proc%, 1))
      Lenght% = Lenght% + FontData%(Letter% - 32, 0)
      IF (Style% AND 2) THEN Lenght% = Lenght% + 1
      Lenght% = Lenght% + 1
   NEXT Proc%
   IF (Style% AND 1) THEN Lenght% = Lenght% + 3
   TextLen% = Lenght%

END FUNCTION

'====================<lpardini@cefex.com>=
'Shows a string using my multispaced font.
'PosX%  Pixel X position
'PosY%  Pixel Y position
'Text$  iso-8859-1 string
'Clr%   Color attribute for printing
'Style% Normal, Bold, Italic, or Bold+Italic
'=========================================
SUB TextPrint (PosX%, PosY%, Text$, Clr%, Style%)
   FOR Proc% = 1 TO LEN(Text$)
      Letter% = ASC(MID$(Text$, Proc%, 1))
      CharPrint PosX%, PosY%, Letter%, Clr%, Style%
   NEXT Proc%
END SUB

'===========================<lpardini@cefex.com>=
'Right-justifies a string using multispaced font.
'PosX%  Right pixel X position
'PosY%  Pixel Y position
'Text$  iso-8859-1 string
'Clr%   Color attribute for printing
'Style% Normal, Bold, Italic, or Bold+Italic
'================================================
SUB TextRight (PosX%, PosY%, Text$, Clr%, Style%)
   RgtPos% = PosX% - TextLen%(Text$, Style%)
   TextPrint RgtPos%, PosY%, Text$, Clr%, Style%
END SUB

